% This program convolves two images. They can be tifs or jpegs (maybe even other formats?)
% The two images must be the same size!
% Austin Roorda, October 9, 1997
close all
clear all


[fname,pname] = uigetfile('*.*','Open a file with the Object')
figure;
image=imread([pname fname]);
colormap(gray);
imshow(image);

[fname,pname] = uigetfile('*.*','Open a file with the PSF')
figure;
PSF=imread([pname fname]);
colormap(gray);
imshow(PSF);

product =fftshift(fft2(double(image))) .* fftshift(fft2(double(PSF)));
convolution = abs(fftshift(ifft2(double(product))));
clear product;

convolution = convolution./max(max(convolution));

figure;
colormap(gray);
imshow(convolution);
name=['images/conv.tif'];
imwrite(convolution,name,'tif');
