% The MTF Is the modulus of the OPTICAL TRANSFER FUNCTION computed from the point spread function
% OTF is the 2-D FFT of the point spread function

PARAMS(4) = PARAMS(2);   %recompute the phasemap to maximize size of PTF and MTF in plots
pupilfunc = Zphase_MahajanOSA(c); 

OTF = conv2(pupilfunc,conj(fliplr(flipud((pupilfunc)))));%autocorrelation

% The MTF is the magnitude of the Optical Transfer Function
MTF = abs(OTF)'; 
MTF = MTF./max(max(MTF)); % scale the MTF so that the peak (at the origin) is equal to 1

% The PTF is the phase of the Optical Transfer Function
PTF = angle(OTF)';

PTF = PTF*180/pi; %convert PTF into degrees

MTF=sign(90-abs(PTF)).*MTF; %this generates an MTF with sign reversals

% Select the subsection within the cutoff frequency for plotting the MTF

cutofffull = 2*(PARAMS(4))/(PARAMS(5)/1000)/57.3;
cutoffaper = 2*(PARAMS(2))/(PARAMS(5)/1000)/57.3;
halfsize = ceil(0.5*(cutoffaper/cutofffull)*PARAMS(1));

MTFaper=MTF;
cutoff=cutofffull/2;

% Define the axes of the MTF plot in cyc/degree
n = size(MTFaper);
axisMTF = -cutoff:2*cutoff/n(1):(cutoff-(2*cutoff/n(1)));

figure('Position',[2*scrsz(3)/5 scrsz(4)/1.8 scrsz(3)/3 scrsz(4)/3]);
mesh(axisMTF,axisMTF, MTF);colorbar;
title('Modulation Transfer Function');
xlabel('c/deg');
ylabel('c/deg');
zlabel('modulation');
xlim([-cutoff cutoff]);
ylim([-cutoff cutoff]);
colormap(hot)

if(1)
v=-195:30:195;
figure('Position',[3*scrsz(3)/5 scrsz(4)/1.8 scrsz(3)/3 scrsz(4)/3]);
imagesc(axisMTF,axisMTF,PTF);colorbar;
title('Phase Transfer Function');
xlabel('c/deg');
ylabel('c/deg');
zlabel('modulation');
xlim([-cutoff cutoff]);
ylim([-cutoff cutoff]);
colormap(hsv);
end

%clear OTF MTF PTF;