% The MTF Is the modulus of the OPTICAL TRANSFER FUNCTION computed from the point spread function
% OTF is the 2-D FFT of the point spread function

OTF = FFT2(PSF);

% The MTF is the real part of the Optical Transfer Function
MTF = fftshift(abs(OTF)); % FFT shift sets the origin to the center of the MTF plot
MTF = MTF./max(max(MTF)); % scale the MTF so that the peak (at the origin) is equal to 1

% Select the subsection within the cutoff frequency for plotting the MTF

cutofffull = (PARAMS(4))/(PARAMS(5)/1000)/57.3;
cutoffaper = (PARAMS(2))/(PARAMS(5)/1000)/57.3;
halfsize = ceil(0.5*(cutoffaper/cutofffull)*PARAMS(1));

%if(halfsize<PARAMS(1))
%   MTFaper = MTF(PARAMS(1)/2-halfsize:PARAMS(1)/2+halfsize,PARAMS(1)/2-halfsize:PARAMS(1)/2+halfsize);
%	cutoff=cutoffaper;   
%else
   MTFaper=MTF;
   cutoff=cutofffull/2;
%end

% Define the axes of the MTF plot in cyc/degree
n = size(MTFaper);
axisMTF = -cutoff:2*cutoff/n(1):(cutoff-(2*cutoff/n(1)));

figure('Position',[scrsz(3)/1.5 scrsz(4)/1.8 scrsz(3)/3 scrsz(4)/3]);
surf(axisMTF,axisMTF,MTFaper);
title('Modulation Transfer Function');
xlabel('c/deg');
ylabel('c/deg');
zlabel('modulation');
xlim([-cutoff cutoff]);
ylim([-cutoff cutoff]);
colormap(hsv)
clear OTF MTF;

