% Zwave_Mahajan is a Matlab function that generates a matrix of the wavefront aberration for the 
% set of coefficients.

waveabermap = Zwave_MahajanOSA(c);
waveabermap=transpose(waveabermap);
n = size(waveabermap);

% Define the axes of the wavefront plot in cyc/degree

axispupil = -PARAMS(2)/2:PARAMS(2)/n(1):(PARAMS(2)/2)-(PARAMS(2)/n(1));

% set parameters and display the wavefront aberration as a mesh plot
v=floor(min(min(waveabermap))):0.25:ceil(max(max(waveabermap)));
%v=(-12:1:8);
scrsz = get(0,'ScreenSize');
figure('Position',[1 scrsz(4)/1.8 scrsz(3)/3 scrsz(4)/3]); %rect = [left, bottom, width, height]
contourf(axispupil, axispupil,waveabermap,v);
%imagesc(axispupil, axispupil,waveabermap);
colormap('default');
colorbar;
title('Wavefront Aberration');
xlabel('mm (right-left)');
ylabel('mm (superior-inferior)');
zlabel('microns');
%figure('Position',[1 scrsz(4)/1.8 scrsz(3)/3 scrsz(4)/3]);
%contour(axispupil, axispupil,waveabermap);
%mesh(axispupil, axispupil,waveabermap);
%title('Wavefront Aberration');
%xlabel('mm (right-left)');
%ylabel('mm (superior-inferior)');
%zlabel('microns');


